package ru.amse.silina.cat.search.impl;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import ru.amse.silina.cat.search.ISearchResult;
import ru.amse.silina.cat.search.ISearcher;
import ru.amse.silina.cat.text.IText;

public class Searcher implements ISearcher {
	private Matcher myMatcher;
	boolean mySearchInDeadSpaces;
	boolean myCrossTranslatedFragmentBorder;
	
	public Searcher(Pattern pattern, IText text, 
			boolean searchInSourceText, boolean searchInDeadSpaces, boolean crossTranslatedFragmentBorder) {
		if (searchInSourceText) {
			myMatcher = pattern.matcher(text.getSourceText());
		} else {
			myMatcher = pattern.matcher(text.getTargetText());
		}
		mySearchInDeadSpaces = searchInDeadSpaces;
		myCrossTranslatedFragmentBorder = crossTranslatedFragmentBorder;
	}

	@Override
	public ISearchResult next() {
		boolean matchFound;
		if (mySearchInDeadSpaces) {
			matchFound = myMatcher.find();	
		} else {
			matchFound = myMatcher.find();
		}
		if (matchFound) {
			return new SearchResult(myMatcher.start(), myMatcher.end() - 1);
		} else {
			return null;
		}
	}
}
